;--------------------------------------------------- - -  -    -
;| Query Blocker  Max Lange
;--------------------------------------------------- - -  -    -
;| Version: 3.2
;| Author: mAx (Max Lange)
;| E-Mail: mail@max-lange.com
;| Website: www.max-lange.com
;| IRC: #addictz (QuakeNet)
;--------------------------------------------------- - -  -    -

alias qb.ini { if ($isid) { return " $+ $scriptdirqblock.ini $+ " } | else {  echo -a $scriptdirqblock.ini  }  }
alias qb { dialog $iif($dialog(qb),-v,-m) qb qb }

menu menubar {
  Addons
  .Query Blocker:qb
}

on ^!*:OPEN:?: {
  if ($nick != -psyBNC) {
    if ($readini($qb.ini,settings,status) == 1) {
      if ($hget(qblocked,$+($nick,!,$address))) { qb.showmsg $nick $1- | haltdef | return }
      if (!%query.flood) { set -u10 %query.flood 1 } | else { inc -u10 %query.flood  } | if (%query.flood >= 5) { writeini $qb.ini settings msg 0 | if ($dialog(qb)) { did -u qb 112 } | if ($dialog(qb.manager)) { did -u qb.manager 10 } | haltdef | return }
      if ($readini($qb.ini,settings,respect) == 1) {
        if (($readini($qb.ini,settings,notifies) == 1) && ($notify($nick))) { return }
        if ($qb.checkmask(Accept,$+($nick,!,$address)) == 1) { return }
        if ($qb.checkmask(Block,$+($nick,!,$address)) == 1) { qb.block $nick $address | qb.showmsg $nick $1- | haltdef | return }
        if ($qb.checkchans(Accept,$nick) == 1) { return }
        if ($qb.checkchans(Block,$nick) == 1) { qb.block $nick $+($nick,!,$address) | qb.showmsg $nick $1- | haltdef | return }
      }
      if ($readini($qb.ini,settings,mode) == 1) {
        qb.block $nick $+($nick,!,$address) | qb.showmsg $nick $1-
        haltdef  | return
      }
      elseif ($readini($qb.ini,settings,mode) == 2) {
        .timer -m 1 0 window -h $nick
        dialog $iif($dialog(qb.manager),-v,-m) qb.manager qb.manager
        .timer -m 1 0 load.nick.in.qbmanager $nick
        if (($readini($qb.ini,settings,msg)) && ($readini($qb.ini,msg,standard))) { .msg $nick $readini($qb.ini,msg,standard) } 
      }
      elseif ($readini($qb.ini,settings,mode) == 3) {
        if ($1- == $readini($qb.ini,settings,password)) { if (($readini($qb.ini,settings,msg)) && ($readini($qb.ini,msg,accepted))) { if ((!$hget(qpass,$nick))  && ($readini($qb.ini,msg,password))) { .msg $nick $readini($qb.ini,msg,password) } | .msg $nick $readini($qb.ini,msg,accepted) } }
        else {
          if (!$hget(qpass,$nick)) { hadd -mu55 qpass $nick 1 | if (($readini($qb.ini,settings,msg)) && ($readini($qb.ini,msg,password))) { .msg $nick $readini($qb.ini,msg,password) }  }
          elseif ($hget(qpass,$nick) < 2) { hinc -u55 qpass $nick }
          else { qb.block $nick $+($nick,!,$address) }
          qb.showmsg $nick $1- | haltdef | return
        }
      }
    }
  }
}

on *:TEXT:*:?: { if ($window($nick).state == hidden) { .timer -m 1 1 add.text.2.qbmanager $nick $1- } }

alias qb.checkmask {
  var %total.entrys = $ini($qb.ini,$+($1,-masks),0)
  var %i = 1 | while (%i <= %total.entrys) {
    if ($ini($qb.ini,$+($1,-masks),%i) iswm $2) { return 1 } | inc %i
  }
  return 0
}

alias qb.block {
  if ($2) { hadd -mu60 qblocked $2 1 }
  if (($readini($qb.ini,settings,msg)) && ($readini($qb.ini,msg,blocked))) { .msg $1 $readini($qb.ini,msg,blocked) }
}

alias qb.showmsg {
  if ($readini($qb.ini,settings,show) == 1) { if (($readini($qb.ini,settings,show.target) == 3) && (!$window(@query-log))) { window -k0z @query.log } | $iif($readini($qb.ini,settings,show.target) != 3,echo -t $+ $iif($readini($qb.ini,settings,show.target) == 1,s,a),aline @query.log $asctime($timestampfmt)) Blocked Query from $iif($cts,$emphasize($1),( $+ $1 $+ )) $2- }
}

alias qb.checkchans {
  if ($readini($qb.ini,$+($1,-chans),op.status)) { var %temp = $readini($qb.ini,$+($1,-chans),op) | var %i = 1,%total = $numtok(%temp,32) | while (%i <= %total) { if ($2 isop $gettok(%temp,%i,32)) { return 1 } | inc %i } }
  if ($readini($qb.ini,$+($1,-chans),hop.status)) { var %temp = $readini($qb.ini,$+($1,-chans),hop) | var %i = 1,%total = $numtok(%temp,32) | while (%i <= %total) { if ($2 ishop $gettok(%temp,%i,32)) { return 1 } | inc %i } }
  if ($readini($qb.ini,$+($1,-chans),voice.status)) { var %temp = $readini($qb.ini,$+($1,-chans),voice) | var %i = 1,%total = $numtok(%temp,32) | while (%i <= %total) { if ($2 isvoice $gettok(%temp,%i,32)) { return 1 } | inc %i } }
  if ($readini($qb.ini,$+($1,-chans),regular.status)) { var %temp = $readini($qb.ini,$+($1,-chans),regular) | var %i = 1,%total = $numtok(%temp,32) | while (%i <= %total) { if ($2 isreg $gettok(%temp,%i,32)) { return 1 } | inc %i } }
  return 0 
}

dialog qb {
  title "Query Blocker"
  size -1 -1 120 146
  option dbu
  tab "Settings", 1, 1 -1 118 145
  box "", 100, 3 13 114 37, tab 1
  radio "Block generally all incoming queries", 101, 6 20 100 8, group tab 1
  radio "Manually accept/block queries", 102, 6 29 90 8, tab 1
  radio "Use password protection", 103, 6 38 74 8, tab 1
  button "!", 104, 82 40 4 4, tab 1
  box "", 110, 3 46 114 27, tab 1
  check "Respect auto accept/block settings", 111, 7 53 101 8, tab 1
  check "Send messages", 112, 7 62 82 8, tab 1
  box "", 120, 3 69 114 58, tab 1
  check "Show blocked queries in:", 122, 7 75 74 8, tab 1
  combo 123, 16 84 97 50, tab 1 size drop
  tab "Accept", 2
  tab "Block", 3
  button "close", 4, 6 129 37 10, ok
  check "active", 5, 46 129 36 10
  box "", 6, 3 123 114 19
  box "", 10, 3 13 114 46, hide
  check "Op:", 11, 7 20 30 8, hide
  edit "", 12, 39 19 75 10, hide autohs
  check "Hop:", 17, 7 29 30 8, hide
  edit "", 18, 39 28 75 10, hide autohs
  check "Voice:", 13, 7 38 30 8, hide
  edit "", 14, 39 37 75 10, hide autohs
  check "Regular:", 15, 7 47 30 8, hide
  edit "", 16, 39 46 75 10, hide autohs
  box "", 20, 3 55 114 72, hide
  list 21, 6 61 109 53, hide size
  check "Notifies", 22, 7 116 34 8, hide
  button "Add", 23, 46 116 33 8, hide
  button "Remove", 24, 81 116 33 8, hide
}

on *:DIALOG:qb:init:*:{ 
  did -a $dname 123 Status window | did -a $dname 123 Active window |  did -a $dname 123 Extra window 
  if ($exists($qb.ini)) {
    if ($readini($qb.ini,settings,status) == 1) { did -c $dname 5 }
    if ($readini($qb.ini,settings,mode) == 2) { did -c $dname 102 } | elseif ($readini($qb.ini,settings,mode) == 3)  { did -c $dname 103 } | else { did -c $dname 101 }
    if ($readini($qb.ini,settings,respect) == 1) { did -c $dname 111 }
    if ($readini($qb.ini,settings,msg) == 1) { did -c $dname 112 } 
    if ($readini($qb.ini,settings,show) == 1) { did -c $dname 122 } | else { did -b $dname 123 }
    if ($readini($qb.ini,settings,show.target) != $null) { did -c $dname 123 $ifmatch } | else { did -c $dname 123 1 }
  }
}

on *:DIALOG:qb:sclick:*: {
  if ($did == 1) { qb.switchhide 1 | unset %temp.qb.tab }
  elseif ($did == 2) { qb.switchhide 0 | if ($readini($qb.ini,settings,notifies) == 1) { did -c $dname 22 } | qb.loadmasks Accept | qb.loadchans Accept | did -e $dname 22 | set %temp.qb.tab Accept }
  elseif ($did == 3) { qb.switchhide 0 | did -u $dname 22 | qb.loadmasks Block | qb.loadchans block | did -b $dname 22 | set %temp.qb.tab block }
  elseif ($did == 5) { if ($did($did).state) { writeini $qb.ini settings status 1 } | else { writeini $qb.ini settings status 0 } }
  elseif ($did == 11) { if ($did($did).state) { writeini $qb.ini $+(%temp.qb.tab,-chans) op.status 1 | did -e $dname 12 } | else { writeini $qb.ini $+(%temp.qb.tab,-chans) op.status 0 | did -b $dname 12 } }
  elseif ($did == 13) { if ($did($did).state) { writeini $qb.ini $+(%temp.qb.tab,-chans) voice.status 1 | did -e $dname 14 } | else { writeini $qb.ini $+(%temp.qb.tab,-chans) voice.status 0 | did -b $dname 14 } }
  elseif ($did == 15) { if ($did($did).state) { writeini $qb.ini $+(%temp.qb.tab,-chans) regular.status 1 | did -e $dname 16 } | else { writeini $qb.ini $+(%temp.qb.tab,-chans) regular.status 0 | did -b $dname 16 } }
  elseif ($did == 17) { if ($did($did).state) { writeini $qb.ini $+(%temp.qb.tab,-chans) hop.status 1 | did -e $dname 18 } | else { writeini $qb.ini $+(%temp.qb.tab,-chans) hop.status 0 | did -b $dname 18 } }
  elseif ($did == 22) { if ($did($did).state) { writeini $qb.ini settings notifies 1 } | else { writeini $qb.ini settings notifies 0 } }
  elseif ($did == 23) { var %temp.qb.1 = $?="Insert Banmask (e.g. nick!ident@host)" | var %temp.qb.2 = $?="Insert Comment (optional)" | if (%temp.qb.1) { did -a $dname 21 %temp.qb.1 ( $+ $iif(%temp.qb.2,%temp.qb.2,1) $+ ) | writeini $qb.ini $+(%temp.qb.tab,-masks) %temp.qb.1 $iif(%temp.qb.2,%temp.qb.2,1) | did -c $dname 21 $did(21).lines } }
  elseif (($did == 24) && ($did(21).sel)) { if ($input(Are you sure?,wy,Delete entry: $did(21).seltext  $+ ?,Delete entry)) {  remini $qb.ini $+(%temp.qb.tab,-masks) $did(21).seltext | var %temp.sel = $did(21).sel | did -d $dname 21 $did(21).sel | if ($did(21).lines > 1) { did -c $dname 21 $calc(%temp.sel -1) }  }  }

  elseif ($did == 101) { writeini $qb.ini settings mode 1 }
  elseif ($did == 102) { writeini $qb.ini settings mode 2 }
  elseif ($did == 103) { writeini $qb.ini settings mode 3 }
  elseif ($did == 104) { var %temp.qb.1 = $input(Password:,129,Query Blocker,$readini($qb.ini,settings,password)) |  if (%temp.qb.1 != $null) { writeini $qb.ini settings password  %temp.qb.1 } }

  elseif ($did == 111) { if ($did($did).state) { writeini $qb.ini settings respect 1 } | else { writeini $qb.ini settings respect 0 } }
  elseif ($did == 112) { if ($did($did).state) { writeini $qb.ini settings msg 1 | if ($dialog(qb.manager)) { did -c qb.manager 10 } } | else { writeini $qb.ini settings msg 0 | if ($dialog(qb.manager)) { did -u qb.manager 10 } } }

  elseif ($did == 122) { if ($did($did).state) { writeini $qb.ini settings show 1 | did -e $dname 123  } | else { writeini $qb.ini settings show 0 | did -b $dname 123 } }
  elseif ($did == 123) { writeini $qb.ini settings show.target $did($did).sel }
}

on *:DIALOG:qb:edit:*: {
  if ($did == 12) { writeini $qb.ini $+(%temp.qb.tab,-chans) op $iif($did($did) != $null,$ifmatch,-) }
  elseif ($did == 14) { writeini $qb.ini $+(%temp.qb.tab,-chans) voice $iif($did($did) != $null,$ifmatch,-) }
  elseif ($did == 16) { writeini $qb.ini $+(%temp.qb.tab,-chans) regular $iif($did($did) != $null,$ifmatch,-) }
  elseif ($did == 18) { writeini $qb.ini $+(%temp.qb.tab,-chans) hop $iif($did($did) != $null,$ifmatch,-) }
}

on *:DIALOG:qb:close:*: {
  unset %temp.qb.tab
  saveini
}

alias qb.loadmasks {
  if ($exists($qb.ini)) {
    did -r qb 21
    var %total.entrys = $ini($qb.ini,$+($1,-masks),0)
    var %i = 1
    while (%i <= %total.entrys) {
      var %temp = $ini($qb.ini,$+($1,-masks),%i)
      did -a qb 21 %temp ( $+ $readini($qb.ini,$+($1,-masks),%temp) $+ )
      inc %i
    }
  }
}

alias qb.switchhide {
  if ($1 == 1) { did -h qb 10,11,12,13,14,15,16,17,18,20,21,22,23,24 | did -v qb 100 }
  else { did -v qb 10,11,12,13,14,15,16,17,18,20,21,22,23,24 | did -h qb 100 }
}

alias qb.loadchans {
  if ($exists($qb.ini)) {
    if ($readini($qb.ini,$+($1,-chans),op.status) == 1) { did -c qb 11 | did -e qb 12 } | else {  did -u qb 11 | did -b qb 12 }
    did -ra qb 12 $iif($readini($qb.ini,$+($1,-chans),op) != $null,$ifmatch,-)

    if ($readini($qb.ini,$+($1,-chans),voice.status) == 1) { did -c qb 13 | did -e qb 14 } | else { did -u qb 13 | did -b qb 14 }
    did -ra qb 14 $iif($readini($qb.ini,$+($1,-chans),voice) != $null,$ifmatch,-)

    if ($readini($qb.ini,$+($1,-chans),regular.status) == 1) { did -c qb 15 | did -e qb 16 } | else { did -u qb 15 | did -b qb 16 }
    did -ra qb 16 $iif($readini($qb.ini,$+($1,-chans),regular) != $null,$ifmatch,-)

    if ($readini($qb.ini,$+($1,-chans),hop.status) == 1) { did -c qb 17 | did -e qb 18 } | else {  did -u qb 17 | did -b qb 18 }
    did -ra qb 18 $iif($readini($qb.ini,$+($1,-chans),hop) != $null,$ifmatch,-)
  }
}

dialog qb.manager {
  title "Query Manager"
  size -1 -1 200 100
  option dbu
  box "", 1, 1 -1 60 86
  box "", 2, 60 -1 139 86
  box "", 3, 1 81 198 19
  button "Accept", 4, 4 87 37 10
  button "Reject", 5, 44 87 37 10
  button "Close (and reject all)", 6, 136 87 60 10, cancel
  list 7, 4 5 54 77, size
  edit "", 8, 63 5 133 23, read multi return autohs autovs
  edit "", 9, 63 29 133 53, read multi return autohs autovs
  check "Messages", 10, 84 87 48 10
}

on *:DIALOG:qb.manager:init:*: {
  if ($readini($qb.ini,settings,msg) == 1) { did -c $dname 10 } 
}

on *:DIALOG:qb.manager:sclick:*: {
  if ($did(7).seltext)  {
    if ($did == 7) { load.nick.in.qbmanager $did(7).seltext }
    elseif (($did == 4) && ($query($did(7).seltext))) { window -wa $did(7).seltext |  if (($readini($qb.ini,settings,msg)) && ($readini($qb.ini,msg,accepted))) { .msg $did(7).seltext $readini($qb.ini,msg,accepted) }  | did -d $dname 7 $did(7).sel | did -r $dname 8,9 | if ($did(7).lines > 0) { did -c $dname 7 1 | load.nick.in.qbmanager $did(7).seltext } | else { dialog -c qb.manager qb.manager } }
    elseif ($did == 5) { qb.block $did(7).seltext $+($did(7).seltext,!,$query($did(7).seltext).addr) | qb.showmsg $query($did(7).seltext) | window -c $query($did(7).seltext) | did -d $dname 7 $did(7).sel | did -r $dname 8,9 | if ($did(7).lines > 0) { did -c $dname 7 1 | load.nick.in.qbmanager $did(7).seltext } | else { dialog -c qb.manager qb.manager } }
  }
  if ($did == 10) { if ($did($did).state) { writeini $qb.ini settings msg 1 | if ($dialog(qb)) { did -c qb 112 } } | else { writeini $qb.ini settings msg 0 | if ($dialog(qb)) { did -u qb 112 } } }
}

on *:DIALOG:qb.manager:close:*: {
  var %i = 1
  while (%i <= $query(0)) {
    if ($window($query(%i)).state == hidden) {
      qb.block $query(%i) $+($query(%i),!,$query(%i).addr) | qb.showmsg $query(%i) | window -c $query(%i)
    }
    else { inc %i }
  }
}

alias load.nick.in.qbmanager {
  if (!$didwm(qb.manager,7,$1)) {
    did -a qb.manager 7 $1
  }
  did -c qb.manager 7 $didwm(qb.manager,7,$1)
  did -r qb.manager 8 | did -r qb.manager 9
  did -a qb.manager 8 Address: $+($1,!,$query($1).addr) $crlf 
  var %i = 1
  while (%i <= $comchan($1,0)) {
    var %comchan = %comchan $comchan($1,%i)
    inc %i
  }
  did -a qb.manager 8 Comchans: $iif(%comchan,$ifmatch,-)
  add.text.2.qbmanager $1
}

alias add.text.2.qbmanager {
  if ($did(qb.manager,7).seltext == $1) {
    did -r qb.manager 9
    var %i = 1
    while (%i <= $line($1,0)) {
      did -a qb.manager 9 $strip($line($1,%i),cbur) $crlf 
      inc %i
    }
  }
}

on *:NICK: {
  if (($query($newnick)) && ($dialog(qb.manager)) && ($didwm(qb.manager,7,$nick))) {
    did -o qb.manager 7 $didwm(qb.manager,7,$nick) $newnick | did -c qb.manager 7 $didwm(qb.manager,7,$newnick) | add.text.2.qbmanager $newnick
  }
}
